\documentclass[10pt,compress]{beamer}
\usepackage[T1]{fontenc}
\usepackage[utf8]{inputenc}
\usepackage{tikz}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{listings}
\usepackage{graphicx}

\newcommand{\R}{\texttt{R}}
\newcommand{\lnk}[2]{\hyperlink{#1<1>}{\beamerreturnbutton{#2}} } % Link to slides by label

%% Alternate "Return Button" footline
\defbeamertemplate{footline}{return}{%
  \parbox{\linewidth}{\vspace*{-10pt}\hfill\lnk{ind}{Return}\hfill\insertpagenumber/\insertpresentationendpage}}

%% Alternate "Return Button" footline for PFS
\defbeamertemplate{footline}{preturn}{%
  \parbox{\linewidth}{\vspace*{-10pt}\hfill\lnk{pind}{Return}\hfill\insertpagenumber/\insertpresentationendpage}}

\setbeamertemplate{navigation symbols}{}
\setbeamertemplate{footline}[frame number]

\begin{document}
<<r setup1, include=FALSE>>=
  knitr::opts_chunk$set(fig.path='figure/beamer-',
                        fig.align='center',
                        fig.show='hold',
                        size='tiny',
                        fig.width=10,
                        fig.height=6,
                        out.width='.9\\linewidth')
@
    
<<setup2, include=FALSE>>=
defaultWidth <- 75              # use to switch between widths for different size code output
tinyWidth <- 150                # use to switch between widths for different size code output
options(width=tinyWidth)        # make the printing fit on the page
opts_chunk$set(tidy = TRUE,
               tidy.opts=list(keep.blank.line=FALSE, width.cutoff=60)) # make code stay in frame
set.seed(1123)                  # make the results repeatable
stdt <- date()
@
  
\begin{frame}
\title{LCCC Preprocessing}
%\date{}
% Date: May 19, 2018
% Author: Kirsten Burdett
\titlepage
\end{frame}

      
%#==========================================================================================#
%#=========================              Introduction         ==============================#
%#==========================================================================================#
\section{Introduction}

\begin{frame}[fragile, label=objective]{Objectives}
Note these will be done at baseline!
\begin{itemize}
	\item \underline{Primary Analysis}: Determine whether VEGF-D of the plasma angiome panel is predictive of progression-free survival (PFS) in patients treated with Regorafenib. "PFS is defined as the time from randomization until mCRC progression or death as a result of any cause."\\
	\vspace{2mm}
		\item \underline{Secondary Analysis 1}: Determine whether 19 other markers of the plasma angiome panel are predictive of progression-free survival (PFS) in patients treated with Regorafenib.\\
			\vspace{2mm}
		\item \underline{Secondary Analysis 2}: Determine whether any of the plasma angiome panel are predictive of overall survival (OS) in patients treated with Regorafenib. "OS is defined as the time from randomization until death as a result of any cause."\\
\end{itemize}
\end{frame}


\begin{frame}[fragile, label=objective]{Exploratory Objectives}
Protocol defines C2D21 as Cycle 2 Dy 21 (+/-) 1 day. Cycle is 28 days. So range for C2D21 is 76-78 days. In order to include more patients we instead will be using C1D21 (+/-) 14 days which is a range of 35-63 days.
\begin{itemize}
 	\item \underline{Exploratory Objective 1}: Determine whether any of the plasma angiome panel are prognostic of PFS or OS in patients treated with Regorafenib.\\
\end{itemize}
Determine the level of change for each marker on treatment.
\begin{itemize}
 	\item Lratio defined as Log2(post trt / baseline) analyzed C1D21 and PD.\\
 	\vspace{2mm}
	\item Waterfall plots and spaghetti plots for C1D21/baseline and PD/baseline. Wilcoxon signed rank test will be used.\\
	\vspace{2mm}
	\item Determine whether changes in levels of markers in the plasma angiome panel are predictive of PFS or OS benefit for baseline to C1D21 and baseline to PD.
\end{itemize}
\end{frame}


\begin{frame}[fragile,label=libs]{Libraries}
Looking at 20 biomarkers and primary analysis is predictive PFS. This was a randomized study looking at FOLFIRI and regorafenib versus FOLFIRI.
<<libs, size='tiny', message = FALSE, error = FALSE>>=
library(gdata)
library(tidyverse)
library(xtable)            # used for creating latex tables from R object
library(readxl)
#library(xlsx)
library(gridExtra)
library(matrixStats)
library(XLConnect)         # allows us to read password protected excel files
@
\end{frame}
      

%#==========================================================================================#
%#============================             Load  Data         ==============================#
%#==========================================================================================#
\section{Data}
\subsection{Load Data}
\begin{frame}[fragile]{Locate the data}
Next, we set the location of the data files and location for output results.
<<locate>>=
savdir <- "/data1/workspace/DCI/Nixon/LCCC/Data/"
dir <- "/data1/workspace/DCI/Nixon/LCCC/Data/"

# Set file name
fname <- file.path(dir,"LCCC1029-stats ready spreadsheet-050918.xlsx")
tools::md5sum(fname)

# Get sheet names
sheetnam <- excel_sheets(fname)
sheetnam

marknams <- gsub("\\-","",sheetnam)
marknams

log2marks <- paste0("log2_base_",marknams)
@
\end{frame}


%=============================================================#
%=========           Load and convert data          ==========#
\begin{frame}[fragile]{Read data}
Function to read in the biomarker data from the excel file and rename Dilution,rep1,rep2 to include the protein name. Also this function combines the replicates according to mean(rep1, rep2)*dilution.
<<readin, size= 'tiny'>>=
rndata <- function(fname, sheet, coltypes, nasymb = ".",
                             Sample_ID=quo(`Sample I.D.`), Dilution=quo(Dilution),
                             rep1=quo(`Repl 1`), rep2=quo(`Repl 2`)) {

     markval <- gsub("\\-","",sheet)

### This function reads in data from a given sheet from the Nixon
### lab spreadsheet with two replicates and returns the average    
    outdat <- read_xlsx(fname, sheet=sheet, col_types = coltypes, na=nasymb) %>%
        transmute(SampID:=!!(Sample_ID), Dilution:=!!(Dilution), rep1=!!(rep1), rep2=!!(rep2)) %>%
        mutate(!!markval:=rowMeans(.[c("rep1","rep2")], na.rm=TRUE)*Dilution) 
    
    ## now we want to rename Dilution, rep1, rep2 to include biomarker
    newrep <- paste0(markval, "_rep1")
    newrep2 <- paste0(markval, "_rep2")
    newdil <- paste0(markval, "_Dilution")
    
    outdat <- outdat %>%
      rename(!!newrep := rep1, !!newrep2 := rep2, !!newdil := Dilution)
    return(outdat)
}
@
\end{frame}

\begin{frame}[fragile]{Merge Biomarker Data}
<<merged, size= 'tiny', messages = FALSE, warnings = FALSE>>=
mycols <- c("text","numeric","numeric","numeric")
test <- rndata(fname, "TGF-b1",mycols)

mydata1 <- lapply(sheetnam, function(x) rndata(fname, x, mycols))

#this function does a full join for multiple datasets "..." means read arbitrary number of arguments
multi_join <- function(byvar, listdat, joinfun, ...){
    require("dplyr")
    output <- Reduce(function(x, y) {joinfun(by=byvar, x, y, ...)}, listdat)
    return(output)
}

newdat <- multi_join(byvar = "SampID", listdat=mydata1, joinfun =full_join)

dim(test)
dim(newdat)
@
\end{frame}

\begin{frame}[fragile]{Pull IDs from Sample ID}
Seperate Sample ID into the sequence number and the date.
<<sampid, size= 'tiny'>>=
newsamp <- str_split(newdat$SampID, "-")

ids <- rep(NA, length(newsamp))
dats <- rep(NA, length(newsamp))
for(i in 1:length(newsamp)){
  ids[i] <- str_trim(newsamp[[i]][1])
  dats[i] <- str_trim(newsamp[[i]][2])
}

newdat$SEQUENCE_NO_ <- ids
newdat$marker_date <- dats
@
\end{frame}


%=============================================================#
%=========              Check Replications          ==========#
\subsection{Check Reps}
\begin{frame}[fragile]{Check Replicates}
Here will will compare the replications to uncover possible measurement issues.
<<checkreps>>=
marknams

repsfun <- function(dat, marks){
  var1 <- paste0(marks,"_rep1")
  var2 <- paste0(marks, "_rep2")
  
  ggplot(dat, aes(x = dat[,var1], y = dat[,var2])) + geom_point(shape = 1) +
    labs(title= paste0(marks, " Reps"), x = var1, y = var2) + 
    theme(plot.title = element_text(hjust = 0.5)) + geom_abline(slope = 1, intercept=0)
}

plotfour <- function(dat, marksplot,i){
r1 <- repsfun(dat, marksplot[i])
r2 <- repsfun(dat, marksplot[i+1])
r3 <- repsfun(dat, marksplot[i+2])
r4 <- repsfun(dat, marksplot[i+3])
grid.arrange(r1, r2,r3,r4, nrow = 2)
}
@
\end{frame}

<<testing22, echo=FALSE, include = FALSE, warning = FALSE, error = FALSE>>=
for(j in 1:5){
  plotfour(as.data.frame(newdat), marknams, 1+((j-1)*4))
}
@

<<testing22b, echo=FALSE,results='asis'>>=
  for(m in 1:5){
    cat("\\begin{frame}[fragile]{Check Replicates}\n",sep="")
    cat(paste("\\includegraphics[width=\\textwidth,",
              "height=\\textheight,keepaspectratio]{figure/beamer-testing22-",
              m, ".pdf}\n", sep=""))
    cat("\\end{frame}\n")
  }
@


\subsection{Bland-Altman}
\begin{frame}[fragile]{Bland-Altman Plots}
The Bland-Altman plot is a way to assess agreement by evaluating the mean difference and estimate the agreement interval.
<<blandaltfun, size= 'tiny'>>=
aggfun <- function(dat2, marks){
  dat <- as.data.frame(dat2)
  var1 <- paste0(marks,"_rep1")
  var2 <- paste0(marks, "_rep2")
  
  dat$mean_2vals <- rowMeans(dat[,c(var1, var2)], na.rm= TRUE)  # mean(rep1, rep2)
  dat$diff2 <- dat[,var1] - dat[,var2]                          # rep1 - rep2 
  
ggplot(dat, aes(x=mean_2vals, y=diff2)) + geom_point() + 
  geom_hline(yintercept = mean(dat$diff2, na.rm=TRUE), colour = "blue", size = 0.5) +  #mean of difference
  geom_hline(yintercept = mean(dat$diff2, na.rm=TRUE) + (1.96 * sd(dat$diff2, na.rm=TRUE)),
             colour = "red", size = 0.5, linetype = "dashed") +    # upper aggreement mean+1.96(sd)
  geom_hline(yintercept = mean(dat$diff2, na.rm=TRUE) - (1.96 * sd(dat$diff2, na.rm = TRUE)),
             colour = "red", size = 0.5, linetype = "dashed") +    # lower aggreement mean - 1.96(sd)
  labs(x = paste0("Mean of ", marks, " Reps") ,y = "Rep 1 - Rep 2")
}

plotfourBA <- function(dat, marksplot,i){
r1 <- aggfun(dat, marksplot[i])
r2 <- aggfun(dat, marksplot[i+1])
r3 <- aggfun(dat, marksplot[i+2])
r4 <- aggfun(dat, marksplot[i+3])
grid.arrange(r1, r2,r3,r4, nrow = 2)
}
@
\end{frame}

<<BAplots, echo=FALSE, include = FALSE, warning = FALSE, error = FALSE>>=
for(j in 1:5){
  plotfourBA(as.data.frame(newdat), marknams, 1+((j-1)*4))
}
@

<<BAb, echo=FALSE,results='asis'>>=
  for(m in 1:5){
    cat("\\begin{frame}[fragile]{Bland-Altman Plots}\n",sep="")
    cat(paste("\\includegraphics[width=\\textwidth,",
              "height=\\textheight,keepaspectratio]{figure/beamer-BAplots-",
              m, ".pdf}\n", sep=""))
    cat("\\end{frame}\n")
  }
@


%#==========================================================================================#
%#=========================              Clinical Data        ==============================#
%#==========================================================================================#
\subsection{Clinical Data}
\begin{frame}[fragile]{Add Phenotype Data}
We read in the password protected clinical data.
<<pheno, size='tiny'>>=
passwordv <- read.csv(file.path(dir,"Password_for_LCCC.txt"), header=FALSE, stringsAsFactors = FALSE)
pass <- passwordv[[1]]

passdat <- loadWorkbook(file.path(dir, "LCCC_1029_4_2018.xlsx"), password = pass)

tools::md5sum(file.path(dir, "LCCC_1029_4_2018.xlsx"))
clin <- readWorksheet(passdat, "lccc_1029_4_2018")
table(clin$dead, exclude = NULL)
table(clin$pfs, exclude = NULL)
@
\end{frame}

\begin{frame}[fragile]{Rename Variables}
Trt A (regorafenib + FOLFIRI) will be names Rego. Trt B (Placebo +  FOLFIRI) will be named Placebo. Also make Unknown, Not Applicable, and missing NA.
<<trtnew, size= 'tiny'>>=
clintest <- unknownToNA(clin, unknown="Unknown")      # make Unknown and "" NAs
clin22 <- unknownToNA(clintest, unknown="Not Applicable")
clin3 <- unknownToNA(clin22, "")
table(clin3$PRIOR_KNOWN_BRAF_RESULTS, clin$PRIOR_KNOWN_BRAF_RESULTS, exclude = NULL)

newclin <- clin3 %>% 
  mutate(Trt = ifelse(tx == "A","Rego","Placebo")) %>%
  select(-tx) %>%
  rename(Stage = STAGING_AT_INITIAL_DIAGNOSIS, 
         KRAS = PRIOR_KNOWN_KRAS_RESULTS, BRAF = PRIOR_KNOWN_BRAF_RESULTS) #rename/relabel

table(newclin$Trt, clin3$tx, exclude = FALSE)
dim(clin); dim(newclin)
@
\end{frame}




%#==========================================================================================#
%#=========================       Data Issues Marker Data        ===========================#
%#==========================================================================================#
\subsection{Date Issues Marker Data}
\begin{frame}[fragile]{Variables in Date Format}
Next we need to make sure all the dates are in the same format. Some examples of date issues.
<<datef, size='tiny'>>=
# make clin dates as.Date instead of POSIXct
newclin <- newclin %>%
  mutate(start_date = as.Date(start_date),
         prog_date = as.Date(prog_date),
         death_date = as.Date(death_date),
         last_contact_date = as.Date(last_contact_date))

dateprobs <- newdat %>%
  filter(SEQUENCE_NO_ %in% c(187,188,189,191,192)) %>%
  select(SEQUENCE_NO_, marker_date)

dateprobs
@
\end{frame}

\begin{frame}[fragile]{Variables in Date Format for Marker Dataset}
Fix dates in marker data. double // need to be / and two date formats. Then get position of second / in order to determine which are YYYY and which are YY.
<<datef22, size='tiny'>>=
#test <- "5/77//29"
#gsub("//","/",test)
newdat2 <- newdat %>%
  mutate(clean_mdate = gsub("//","/",newdat$marker_date))

dim(newdat2); dim(newdat)

position_both <- gregexpr("/",newdat2$clean_mdate)           # get position of all /
second_pos <- sapply(position_both, function(x) x[2])        # only keep position of second /


#test it works
yearval <- str_sub(newdat2$clean_mdate[1],second_pos[1]+1)   # pull the year (after last /)
                                                             # used +1 since position is / and don't need to keep that 
yearval
newdat2$clean_mdate[1]
@
\end{frame}


\begin{frame}[fragile]{Get lengths of date vars}
<<datef22b, size='tiny'>>=
length_year <- rep(NA, length(second_pos))
for(i in 1:length(second_pos)){
  length_year[i] <- str_sub(newdat2$clean_mdate[i], second_pos[i] + 1)
}

length(length_year); length(newdat2$clean_mdate)

head(data.frame(newdat2$SEQUENCE_NO_, newdat2$clean_mdate, length_year))
table(nchar(length_year))
@
\end{frame}

\begin{frame}[fragile]{Final Dates for Marker Data}
<<datef22c, size='tiny'>>=
# dates are either in dd/mm/YYYY or mm/dd/yy
newdat2 <- newdat2 %>%
  mutate(final_mdate = ifelse(nchar(length_year) == 4, 
                               as.Date(clean_mdate, "%d/%m/%Y"),
                               as.Date(clean_mdate, "%m/%d/%y"))) 

newdat2 <- newdat2 %>%
  mutate(final_mdate = as.Date(final_mdate, origin = "1970-01-01"))

head(data.frame(newdat2$SEQUENCE_NO_, newdat2$marker_date, newdat2$clean_mdate, newdat2$final_mdate))

sum(is.na(newdat2$marker_date)); sum(is.na(newdat2$final_mdate))
@
\end{frame}

\begin{frame}[fragile]{Check dates}
<<datef22e, size='tiny'>>=
dateprobs2 <- newdat2 %>%
  filter(SEQUENCE_NO_ %in% c(187,188,189,191,192)) %>%
  select(SEQUENCE_NO_, marker_date, final_mdate)

dateprobs2
@
\end{frame}



%#==========================================================================================#
%#=========================              Merge Data          ===============================#
%#==========================================================================================#
\subsection{Merge Data}
\begin{frame}[fragile]{Merge Data}
Merge the phenotypic and biomarker data. Clinical data had 181 SubID, but marker only had 174.
<<pmerge, size='tiny'>>=
#do not need rep1, rep2, and dilution for markers
markerdatf <- newdat2 %>%
  select(SampID, SEQUENCE_NO_, final_mdate, marknams)

length(unique(newclin$SEQUENCE_NO_)); length(unique(markerdatf$SEQUENCE_NO_))

LCCCdat <- full_join(x=markerdatf, y=newclin, by="SEQUENCE_NO_")
dim(LCCCdat)
@  
Check with clinician for variables of interest. Here we remove samples with no clinical data.
<<rename, size = 'tiny'>>=
noclindat <- LCCCdat$SEQUENCE_NO_[is.na(LCCCdat$start_date) & is.na(LCCCdat$prog_date) 
                                  & is.na(LCCCdat$death_date) & is.na(LCCCdat$dcensor) 
                                  & is.na(LCCCdat$pcensor) & is.na(LCCCdat$dtime) 
                                  & is.na(LCCCdat$ptime) & is.na(LCCCdat$pfstime) 
                                  & is.na(LCCCdat$pfscensor)]

nomarkdat <- LCCCdat$SEQUENCE_NO_[which(is.na(LCCCdat[,marknams]))]  #no marker data
nomarkdat2 <- nomarkdat[which(!is.na(nomarkdat))]

remove_subjid <- c(noclindat, nomarkdat2)
@  
\end{frame}


\begin{frame}[fragile]{Remove Observations}
Create LCCCdat2 with subjects removed with no clinical data or no marker data. There were 11 subjects removed.
<<datevarf, size = 'tiny'>>=
remove_subjid   #remove subjects with no clinical and no biomarker data

LCCCdat2 <- LCCCdat %>%
  filter(!SEQUENCE_NO_ %in% remove_subjid) 

dim(LCCCdat); dim(LCCCdat2)
#should have 181 unique subjids (9 do not have biomarker data so 172)
length(unique(LCCCdat2$SEQUENCE_NO_))
@  
\end{frame}


\begin{frame}[fragile]{Death Date Issues}
Remove observations where the death date(death\_date) is before the marker date(final\_mdate). LCCCdat2b is the dataset with the dates removed for subject 150, 251, and 269.
<<datevarf2b, size = 'tiny'>>=
death_mark <- LCCCdat2 %>%
  group_by(SEQUENCE_NO_) %>%
  filter(death_date < final_mdate) %>%
  select(SEQUENCE_NO_, death_date, final_mdate)
  
death_mark

LCCCdat2b <- LCCCdat2 %>%
  filter(!(SEQUENCE_NO_ %in% death_mark$SEQUENCE_NO_ & death_date %in% death_mark$death_date
           & final_mdate %in% death_mark$final_mdate))

dim(LCCCdat2);  dim(LCCCdat2b)
@  
\end{frame}


\begin{frame}[fragile]{Death Date Issues}
Here is the original data
<<datevarf2, size = 'tiny'>>=
LCCCdat2 %>% filter(SEQUENCE_NO_ %in% c(150,251, 269)) %>% select(SEQUENCE_NO_, death_date, final_mdate)
@
Then the data with death issue observations removed.
<<datevarf2bb, size = 'tiny'>>=
LCCCdat2b %>% filter(SEQUENCE_NO_ %in% c(150,251, 269)) %>% select(SEQUENCE_NO_, death_date, final_mdate)
@  
\end{frame}

%=============================================================#
%==============   Create Baseline and Cycles  ================#
%=============================================================#
\section{Create Cycles}
\begin{frame}[fragile]{Create Cycle Variable}
Create a Cycle variable which determines which biomarker values are from baseline, C1D21, PD
<<cycles, size = 'tiny'>>=
#first we will look at to see the differences in dates
#start_date is start of Trt date
LC3 <- LCCCdat2b %>%
  mutate(diffdate = (as.numeric(final_mdate - start_date) / 30.5))  # convert days to months 

dim(LC3); dim(LCCCdat2b)

#use checkcycle to look at the variables of interest
checkcycle <- LC3 %>% select(SEQUENCE_NO_, final_mdate, start_date, diffdate)
head(checkcycle)
@  
\end{frame}


\begin{frame}[fragile]{Strange Low Values}
For subject 210 we will use the 0 value as baseline and delete the observation <-100 since it seems to be in error.
<<lowval, size = 'tiny'>>=
head(table(LC3$diffdate, exclude = NULL))

lowmin <- LC3$SEQUENCE_NO_[which(LC3$diffdate<=-100)]

show_low <- LC3 %>%
  filter(SEQUENCE_NO_ %in% lowmin) %>%
  select(SEQUENCE_NO_, diffdate, final_mdate, start_date)

show_low

LC4 <- LC3 %>%
  filter(!diffdate <= -100)

dim(LC3); dim(LC4)
@  
\end{frame}

\begin{frame}[fragile]{Create min max flags}
<<cycleflags, size = 'tiny'>>=
datesummary <- LC4 %>%
  group_by(SEQUENCE_NO_) %>%
  summarize(min_diff = min(diffdate),max_diff =max(diffdate))

combdate <- full_join(LC4, datesummary, by="SEQUENCE_NO_")
dim(LC4); dim(combdate)
@  
View flagged data.
<<cycleflags2, size = 'tiny'>>=
middledate <- combdate %>%
  filter(diffdate > min_diff & diffdate < max_diff) %>%
  group_by(SEQUENCE_NO_) %>%
  summarize(min_c1d21 = min(diffdate), max_c1d21 = max(diffdate), N = n())

table(middledate$N)
middledate[middledate$N == 2,]
@  
\end{frame}


\begin{frame}[fragile]{View Flagged Data: Combdate Cont.}
<<cycleflags2b, size = 'tiny'>>=
# here I just chose to keep the max middle value 
# (only 1 subjects had 2 middle values, subjid 256)
add_mid <- middledate %>%
  select(SEQUENCE_NO_, max_c1d21)

combdate_new <- full_join(combdate, add_mid, by="SEQUENCE_NO_")

head(combdate_new[,c("SEQUENCE_NO_","final_mdate", "start_date",
                     "diffdate","min_diff","max_c1d21", "max_diff")],10)
@  
\end{frame}

\begin{frame}[fragile]{Create Baseline Flag}
<<cylcevar, size = 'tiny'>>=
finaldat <- combdate_new %>%
  mutate(Cycle = "NA") %>%
  select(-SampID)  # don't need this, same as SEQUENCE_NO_ and final_mdate

# make baseline the lowest value per patient (min_diff), also diffdate needs to be less than or equal to 0 

finaldat$Cycle[(finaldat$diffdate <=0) & (finaldat$min_diff == finaldat$diffdate)] <- "Baseline"
table(finaldat$Cycle)
@  
Only keep subjects with baseline for other two timepoints.
<<basekeep, size = 'tiny'>>=
basesub <- finaldat$SEQUENCE_NO_[finaldat$Cycle == "Baseline"]  #only keep subjects that had baseline
length(basesub)

timedat <- finaldat %>%    #subset to subjects that have baseline
  filter(SEQUENCE_NO_ %in% basesub)
table(timedat$Cycle, exclude = NULL)
@  
\end{frame}


\begin{frame}[fragile]{Patients with Prog date = biomarker date}
<<>>=
#finaldat is before removing subj with no baseline
finaldat %>%
  select(SEQUENCE_NO_, Cycle, final_mdate, start_date, diffdate, prog_date, death_date, diffdate, pfstime, dtime) %>%
  print(n=4)
length(which(finaldat$final_mdate == finaldat$prog_date | finaldat$final_mdate == finaldat$death_date ))

timedat %>%
  select(SEQUENCE_NO_, Cycle, final_mdate, start_date, diffdate, prog_date, death_date, diffdate, pfstime, dtime) %>%
  print(n=4)
length(which(timedat$final_mdate == timedat$prog_date | timedat$final_mdate == timedat$death_date))
@
\end{frame}


%=============================================================#
%===========   Create Dataset for timedep Cox  ===============#
%=============================================================#
\section{Time Dep Data}
\begin{frame}[fragile]{Time Dependent Transformation}
<<timedepdat>>=
# function to get data for one subj and arranged by diffdate
forsubj <- function(dat, subj){
  subjdat <- dat %>%
    arrange(SEQUENCE_NO_, diffdate) %>%
    filter(SEQUENCE_NO_ == subj)
}

###======= function to create time dep data   ==============###
timedepfun <- function(dat, subj){
  filtdat <- forsubj(dat, subj)  # arrange by diffdate and subj, filter by subj
  filtdat$pfsT2 <- NA            # create pfsT2 to be the second timepoint
  for(i in 1:(dim(filtdat)[1]-1)){
    new <- filtdat$diffdate[i+1]
    filtdat$pfsT2[i] <- new
  }  
  
  # create pfstime val: note that each subj only has one dtime and pfstime
  event_time <- as.numeric(filtdat %>% filter(is.na(pfsT2)) %>% select(pfstime))  
  newdat <- filtdat %>% mutate(pfsT2 = replace(pfsT2, is.na(pfsT2), event_time))   #replace NA with event time
  
  # want to be in range of prog biomarker (-7,+30days) also need pfs to be 1
  firstout <- newdat %>%
  mutate(PFS_new = if_else(diffdate < pfstime-.25 | is.na(pfstime), 0,
                           if_else(diffdate > pfstime+1, 0,
                                   if_else(pfs==0, 0, 1))))

  # rename diffdate, and create censored pfs time dep also make neg pfsT1 0
  finalout <- firstout %>%
    mutate(pfsT1 = replace(diffdate, diffdate<=0, 0)) %>%
    select(SEQUENCE_NO_, final_mdate, start_date, prog_date, death_date,  pfstime, dtime, pfsT1, pfsT2, PFS_new, dead, pfs, everything()) %>%
    select(-diffdate)

  return(finalout)
}
@
\end{frame}


\begin{frame}[fragile]{Time Dependent Transformation: ISSUES}
<<timedepdat2>>=
newest <- timedepfun(timedat, 101)  #timedat is the baseline only data
newest[,1:13]

newest2 <- timedepfun(timedat, 159); newest2[,1:13]
newest3 <- timedepfun(timedat, 201); newest3[,1:13]
@
\end{frame}


\begin{frame}[fragile]{Time2 < Time1}
<<timedepdat3>>=
subjs <- as.numeric(unique(timedat$SEQUENCE_NO_))  #create vector of numeric subj#
timeDAT <- lapply(subjs, function(x) timedepfun(timedat, x))  # timedat for all subjs
Ftimedep <- bind_rows(timeDAT)

dim(Ftimedep); dim(timedat)

dim((Ftimedep[Ftimedep$pfsT1 > Ftimedep$pfsT2 ,]))
head((Ftimedep[Ftimedep$pfsT1 > Ftimedep$pfsT2 ,]))
@
\end{frame}



\begin{frame}[fragile]{Use Death instead of PFS}
<<deathtimedat>>=
###======= function to create time dep data deathcensor   ==============###
timedepfunOS <- function(dat, subj){
  filtdat <- forsubj(dat, subj)  # arrange by diffdate and subj, filter by subj
  filtdat$osT2 <- NA            # create osT2 to be the second timepoint
  for(i in 1:(dim(filtdat)[1]-1)){
    new <- filtdat$diffdate[i+1]
    filtdat$osT2[i] <- new
  }  
  
  # create osT2 val: note that each subj only has one dtime 
  event_time <- as.numeric(filtdat %>% filter(is.na(osT2)) %>% select(dtime))  
  newdat <- filtdat %>% mutate(osT2 = replace(osT2, is.na(osT2), event_time))   #replace NA with event time
  
  # want to be in range of prog biomarker (-7,+30days) also need os to be 1
  firstout <- newdat %>%
    mutate(OS_new = if_else( (osT2 == dtime) & pfs == 1, 1, 0))

  # rename diffdate, and create censored os time dep also make neg osT1 0
  finalout <- firstout %>%
    mutate(osT1 = replace(diffdate, diffdate<=0, 0)) %>%
    select(SEQUENCE_NO_, final_mdate, start_date, prog_date, death_date,  pfstime, dtime, osT1, osT2, OS_new, dead, pfs, everything()) %>%
    select(-diffdate)

  return(finalout)
}
@
\end{frame}


\begin{frame}[fragile]{Check for Issues timedep OS}
<<deathtimedep2>>=
testOS <- timedepfunOS(timedat, 101)  
testOS[,1:13]

testOS2 <- timedepfunOS(timedat, 159); testOS2[,1:13]
testOS3 <- timedepfunOS(timedat, 201); testOS3[,1:13]
@
\end{frame}

\begin{frame}[fragile]{Check for osT1 > osT2}
<<deathtimedep3>>=
timeDATOS <- lapply(subjs, function(x) timedepfunOS(timedat, x))
FtimedepOS <- bind_rows(timeDATOS)

dim(FtimedepOS); dim(timedat)

dim(FtimedepOS[FtimedepOS$osT1 > FtimedepOS$osT2 ,])
FtimedepOS[FtimedepOS$osT1 > FtimedepOS$osT2 ,]
@
\end{frame}


\begin{frame}[fragile]{More issues}
<<deathtimedep4>>=
unique(timedat$SEQUENCE_NO_[timedat$pfs == 0])
unique(timedat$SEQUENCE_NO_[timedat$final_mdate > timedat$last_contact_date])


timedat %>% filter(final_mdate > last_contact_date) %>%
   select(SEQUENCE_NO_, final_mdate, start_date, last_contact_date, prog_date, death_date,  pfs, dead, diffdate, pfstime, dtime)


testOS2 <- timedepfunOS(timedat, 267); testOS2[,1:13]
@
\end{frame}

\begin{frame}[fragile]{Save Time Dependent Data}
<<savetimedat, size = 'tiny'>>=
timedepdat <- FtimedepOS
timedep <- paste0(savdir,"timedep.RData")
save(timedepdat , file=timedep)
tools::md5sum(timedep)
@  
\end{frame}




%=============================================================#
%=============   Cont Cycle make PD and C1D21  ===============#
%=============================================================#
\section{Continue Cycle}
\begin{frame}[fragile]{Create next 2 timepoints from timedat}
Next Cycle variables will be C1D21 +/- 2 weeks (14days) and PD which will be PD (-7 days PD < PD < + 30 days PD)
<<cylcevar2, size = 'tiny'>>=
#===== PD ====#
timedat$Cycle[(timedat$diffdate >= (timedat$pfstime - .25)) & 
                (timedat$diffdate <= (timedat$pfstime + 1))] <- "PD"
table(timedat$Cycle, exclude = NULL)

#=====  C1D21 =====#  # use +/- 14 days for C1D21 (35,63)
timedat$Cycle[(timedat$diffdate >= (35/30.4167) & timedat$diffdate <= (63/30.4167))] <- "C1D21"
table(timedat$Cycle, exclude = NULL)
@  
\end{frame}


\begin{frame}[fragile]{Show subject overlap}
Subjects with overlap between C1D21 and PD were categorized as C1D21.
<<cylcevar3, size = 'tiny'>>=
timedat %>%
  filter(SEQUENCE_NO_ %in% c("181" ,"205" ,"213" ,"225", "247", "261" ,"276", "299" ,"309", "316")) %>%
  select(SEQUENCE_NO_, final_mdate, start_date, Cycle, prog_date)
@  
\end{frame}

\begin{frame}[fragile]{Remove variables}
Remove diffdate, min\_diff, max\_diff, max\_c1d21
<<removevars, size = 'tiny'>>=
finald <- timedat %>%
  select( - min_diff, -max_diff, -max_c1d21)
@  
Here we check if there are any duplicates. C1D21 has 3 duplicates, and PD has 1.
<<>>=
base_t <- finald %>% filter(Cycle == "Baseline")
pd_t <- finald %>% filter(Cycle == "PD")
c1_t <- finald %>% filter(Cycle == "C1D21")

length(unique(base_t$SEQUENCE_NO_));  length(unique(pd_t$SEQUENCE_NO_))
length(unique(c1_t$SEQUENCE_NO_)); 

table(finald$Cycle)
@
\end{frame}


\begin{frame}[fragile]{Duplicates for PD}
Removed 201 marker date of 2013-09-24. Confirmed with Andy. 
<<remove201, size = 'tiny'>>=
finald %>% filter(SEQUENCE_NO_ == 201) %>% select(SEQUENCE_NO_, final_mdate, start_date, Cycle, prog_date)

finald2 <- finald %>%
  filter(!(SEQUENCE_NO_ == 201 & final_mdate == "2013-09-24"))

dim(finald); dim(finald2)
@  
\end{frame}

\begin{frame}[fragile]{Duplicates for C1D21}
Removed dates for 256 date 2014-05-13, and 307 date 2015-05-11 after discussing with Andy. Also made 213 date 2013-11-05 PD instead of C1D21.
<<c1dups, size = 'tiny'>>=
finald2 %>% filter(SEQUENCE_NO_ %in% c(213, 256, 307)) %>% select(SEQUENCE_NO_, final_mdate, start_date, Cycle, prog_date)

finald3 <- finald2 %>%
  filter(!(SEQUENCE_NO_ == 256 & final_mdate == "2014-05-13")) %>%
  filter(!(SEQUENCE_NO_ == 307 & final_mdate == "2015-05-11"))

#make 213 date 2013-11-05 PD
finald3$Cycle[finald3$SEQUENCE_NO_ == 213 & finald3$final_mdate == "2013-11-05"] <- "PD"
@  
\end{frame}

\begin{frame}[fragile]{Duplicates for C1D21 and PD: Results}
<<c1dupsres, size = 'tiny'>>=
finald3 %>% filter(SEQUENCE_NO_ %in% c(213, 256, 307)) %>% select(SEQUENCE_NO_, final_mdate, start_date, Cycle, prog_date)

dim(finald2); dim(finald3)
@  
\end{frame}


\begin{frame}[fragile]{Show subj with NA}
<<PDprob333, size = 'tiny'>>=
finald3 %>% filter(!(Cycle %in% c("Baseline", "C1D21", "PD"))) %>%
  select(SEQUENCE_NO_, final_mdate, start_date, last_contact_date, prog_date, death_date, diffdate, pfstime, dtime, pfs, dead) %>% print(n=52)
@  
\end{frame}


\begin{frame}[fragile]{Cycle Check}
Make sure that each subject only has one baseline and one PD. What should we do for subject 201?
<<PDprob, size = 'tiny'>>=
based <- finald3 %>% filter(Cycle == "Baseline")
c1d21D <- finald3 %>% filter(Cycle == "C1D21")
PD <- finald3 %>% filter(Cycle == "PD")

basemark <- paste0("base_", marknams)
c1mark <- paste0("c1_",marknams)
pdmark <- paste0("pd_",marknams)

length(unique(based$SEQUENCE_NO_)); length(unique(c1d21D$SEQUENCE_NO_)); length(unique(PD$SEQUENCE_NO_))
table(finald3$Cycle)
@  
\end{frame}




\begin{frame}[fragile]{Save for Spaghetti Data}
Save data for spaghetti plots before transformation.
<<spadat, size = 'tiny'>>=
SpaDat <- finald3
spadat <- paste0(savdir,"spadat.RData")
save(SpaDat, file=spadat)
tools::md5sum(spadat)
@  
\end{frame}





%=============================================================#
%===================   Transformations   =====================#
%=============================================================#
\section{Transformations}
\begin{frame}[fragile]{Prep for LRatio: Base}
Put the cycle in front of each marker in order to create lratio.
<<cyclepre2, size = 'tiny'>>=
prepfun <- function(dat, cyclenam, markin){
  newmark <- paste0(cyclenam, "_", markin)
  new_mdate <- paste0(cyclenam, "_mdate")
  
  newdat <- dat
  names(newdat)[names(newdat) %in% markin] <- newmark  # rename markers
  check1 <- head(data.frame(dat$VEGFD, newdat[,paste0(cyclenam, "_VEGFD")]))  # check it works
  
  #rename final_mdate
  newdat <- newdat %>%
    rename(!!new_mdate := final_mdate)
  
  check2 <-head(data.frame(dat$final_mdate, newdat[,new_mdate]))  # check it works
  
  return(list(newdat = newdat, check1 = check1, check2 = check2))
}

baseout <- prepfun(based, "base", marknams)
new_base <- baseout[[1]]

head(new_base[,c("SEQUENCE_NO_","start_date", "base_IL6", "base_mdate")])
@
\end{frame}

\begin{frame}[fragile]{Prep for LRatio: PD}
<<pdprep, size = 'tiny'>>=
pdout <- prepfun(PD, "pd", marknams)
new_pd <- pdout[[1]]

new_pd <- new_pd %>%
  select(SEQUENCE_NO_, start_date, pdmark, pd_mdate) # keep pdmarkers, pd_mdate,
                                                     # also SEQUENCE_NO_ and start_date for merge
pdout[[2]]
head(new_pd[,c("SEQUENCE_NO_","start_date", "pd_IL6", "pd_mdate")])
@
\end{frame}

\begin{frame}[fragile]{Prep for LRatio: C1D21}
<<pdprep2, size = 'tiny'>>=
c1out <- prepfun(c1d21D, "c1", marknams)
new_c1 <- c1out[[1]]

new_c1 <- new_c1 %>%
  select(SEQUENCE_NO_, start_date, c1mark, c1_mdate)  # keep c1markers, c1_mdate, 
                                                      # also SEQUENCE_NO_ and start_date for merge
c1out[[2]]
names(new_c1)
@
\end{frame}

\begin{frame}[fragile]{Merge base, c1, and pd data}
Convert dataset from long to wide in order to do exploratory analysis. There are 149 unique subject with at least one baseline and potentially pd or c1d21 marker data as well.
<<mergecvycle, size = 'tiny'>>=
cm1 <- full_join(new_base, new_pd, by = c("SEQUENCE_NO_", "start_date")) # merge base and pd data
cm2 <- full_join(cm1, new_c1, by = c("SEQUENCE_NO_", "start_date"))      # merge c1 data
dim(new_base); dim(cm2)

length(unique(cm2$SEQUENCE_NO_))
cm2 %>% select(SEQUENCE_NO_, start_date, base_mdate, base_IL6, c1_mdate, c1_IL6, pd_mdate, pd_IL6) %>%
  head()
@
\end{frame}

\begin{frame}[fragile]{Create L-Ratio}
L-Ratio is defined as Log2(post trt level/ baseline level). We will have LRc1 and LRpd for the L-Ratio of C1D21 and PD respectively. 
<<lratiofinal, size = 'tiny'>>=
for(i in 1:length(marknams)){
  cm2[,paste0("LRc1_",marknams[i])] <- log2(cm2[,c1mark[i]] / cm2[,basemark[i]])  # log2(c1/base)
  cm2[,paste0("LRpd_",marknams[i])] <- log2(cm2[,pdmark[i]] / cm2[,basemark[i]])  # log2(pd/base)
}
@
Check Results
<<lratiofinalcheck, size = 'tiny'>>=
cm2 %>% select(SEQUENCE_NO_, base_IL6, c1_IL6, pd_IL6, LRc1_IL6, LRpd_IL6) %>%
  head()

log2(15.1/2.92)  # LRc1 for ID 101
log2(10.3/1.79)  # LRpd for ID 102
@
\end{frame}

\begin{frame}[fragile,label=dat]{Analysis Variables}
We will need log2-adjusted versions of each marker and may wish to dichotomize by median expression for illustrative purposes.
<<include=FALSE>>=
options(width=tinyWidth)
@
<<anvars,size='tiny'>>=
cm2 <- as.data.frame(cm2)
for(i in 1:length(basemark)){
  cm2[,paste0("med_",basemark[i])] <- ifelse(cm2[,basemark[i]] <= median(cm2[,basemark[i]], na.rm=T), 0, 1) 
  cm2[,paste0("log2_",basemark[i])] <- log2(cm2[,basemark[i]])                                 
}

##Check it worked
head(cm2$base_IL6)
head(cm2$log2_base_IL6)
log2(cm2$base_IL6[1])
@
<<include=FALSE>>=
options(width=defaultWidth)
@
\end{frame}


\begin{frame}[fragile]{Plotting Function}
This function plots the markers and allows us to assess if there are any outliers (i.e. large values that could influence the statistics), or if a log-transformation is required. 
<<include=FALSE>>=
options(width=tinyWidth)
@
<<jitterbox, size='tiny'>>=
jitterboxes <- function(dat, marker){
  par(mfrow=c(2,1))
    boxplot(dat[,marker], outpch = NA, horizontal = TRUE, 
            xlab=paste0(marker,", n=",sum(!is.na(dat[,marker]))) )
    stripchart(dat[dat$survstat==2,marker], pch=1,
               vertical = FALSE, method = "jitter", jitter=0.075, add = TRUE) 
    stripchart(dat[dat$survstat==1,marker], pch=4,
               vertical = FALSE, method = "jitter", jitter=0.075, add = TRUE) 
  
  boxplot(dat[,paste("log2",marker,sep="_")], outpch = NA, horizontal = TRUE, 
          xlab=paste("log2(",marker,"), n=",sum(!is.na(dat[,paste("log2",marker, sep="_")]))) )
  stripchart(dat[dat$survstat==2,paste("log2",marker,sep="_")], pch=1,
             vertical = FALSE, method = "jitter", jitter=0.075, add = TRUE) 
  stripchart(dat[dat$survstat==1,paste("log2",marker,sep="_")], pch=4,
             vertical = FALSE, method = "jitter", jitter=0.075, add = TRUE) 
}
@
<<include=FALSE>>=
options(width=defaultWidth)
@
\end{frame}

%% Loop through all markers for log transformations %%
<<testingg, echo=FALSE, include = FALSE>>=
for(i in 1:length(basemark)){
jitterboxes(cm2, basemark[i])
}
@

<<jitterplot, echo=FALSE,results='asis'>>=
for(m in 1:length(basemark)){
cat("\\begin{frame}[fragile]{",marknams[m]," Log2 Transformation}\n",sep="")
cat("\\texttt{Check log2 transformation.}\n",sep="")
  cat(paste("\\includegraphics[width=\\textwidth,",
            "height=\\textheight,keepaspectratio]{figure/beamer-testingg-",
            m, ".pdf}\n", sep=""))
cat("\\end{frame}\n")
}
@


%=============================================================#
%======================   OUTLIERS  ==========================#
%=============================================================#
\section{Outliers}
\begin{frame}[fragile]{Potential Outlier Effects}
This table identifies the markers that were considered outliers, and compares them to the median. Outliers are considered as values outside of (Q1 -1.5(IQR), 1.5(IQR) + Q3)
<<maxvals, size = 'tiny'>>=
# outfun gives the outliers
outfun <- function(dat, markin){
  lowerout <- rep(NA,length(markin))
  upperout <- rep(NA, length(markin))
  
  for(i in 1:length(markin)){
  summ <- summary(dat[,markin[i]])            # get summary stats (Q1 and Q3)
  IQRval <- IQR(dat[,markin[i]], na.rm=TRUE)  # get IQR
  lowerout[i] <- summ["1st Qu."] - 1.5*IQRval   # lower outlier value
  upperout[i] <- summ["3rd Qu."] + 1.5*IQRval   # upper outlier value
  }
  outresults <- data.frame(markin, lowerout, upperout, stringsAsFactors = FALSE)
  return(outresults)
}
outliers <- outfun(cm2, log2marks)

# sumout() gets the total number of values that are outliers for each marker
sumout <- function(dat, outdat, markerval){
  upout <- outdat$upperout[outdat$markin == markerval]
  lowout <- outdat$lowerout[outdat$markin == markerval]
  sumres <- sum(dat[,markerval] > upout | dat[,markerval] < lowout, na.rm=TRUE)
  return(sumres)
}
outliers$Total_out <- sapply(log2marks, function(x) sumout(cm2, outliers, x))
outliers$N <- sapply(log2marks, function(x) (length(cm2[,x]) - sum(is.na(cm2[,x]))))
@
\end{frame}

\begin{frame}[fragile]{Outliers Table}
Table of outliers range and the total number of outliers.
<<maxvals2, size = 'tiny'>>=
outliers
@
\end{frame}

\begin{frame}[fragile]{Variables with outliers removed added to data}
To examine the effects of outliers, we create versions of the variables with the outliers removed. We need log-adjusted versions of each variable.
<<outdat, size = 'tiny'>>=
mv <- log2marks
LCCCf <- cm2
for(m in 1:length(mv)){
  upout <- outliers$upperout[outliers$markin == mv[m]]
  lowout <- outliers$lowerout[outliers$markin == mv[m]]
  # these outlier variables are the log2 outliers
  LCCCf[,paste0("out", mv[m])] <- LCCCf[,mv[m]]
  LCCCf[,paste0("out", mv[m])][LCCCf[,mv[m]] > upout | LCCCf[,mv[m]] < lowout] <- NA

  ranks <- LCCCf[,mv[m]]
  ranks[!is.na(ranks)] <- rank(ranks, na.last = NA)
  LCCCf[,paste0(mv[m],"rank")] <- ranks
}
dim(finald)
dim(LCCCf)
@
\end{frame}

\begin{frame}[fragile]{Covariates}
Here are potential covariates. Need to talk with the clinician to determine covariates of interest.
<<covariatesummary, size = 'tiny'>>=
table(LCCCf$Trt, exclude = NULL)
table(LCCCf$PERFORMANCE_STATUS, exclude = NULL)
table(LCCCf$Stage, exclude = NULL)
table(LCCCf$dead, exclude = NULL); table(LCCCf$pfs, exclude = NULL)
@  
\end{frame}

%=============================================================#
%===================     SAVE RESULTS     ====================#
%=============================================================#
\section{Save the Results}
\begin{frame}[fragile]{Save the Results}

Lastly, we save our results for use in the analysis.
<<save>>=
savfile <- paste0(savdir,"LCCCf.RData")
save(LCCCf, file=savfile)
tools::md5sum(savfile)
@
\end{frame}

\section*{Session Information}
\begin{frame}[fragile]{Session Information}
<<sessinfo, echo=FALSE,results='asis'>>=
toLatex(sessionInfo(), locale=FALSE)
@
<<sesstime, echo=FALSE>>=
print(paste("Start Time",stdt))
print(paste("End Time  ",date()))
@
\end{frame}

\end{document}
